//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  2
#property indicator_color1   LimeGreen
#property indicator_color2   DarkOrange
#property indicator_width1   2
#property indicator_width2   2
#property indicator_minimum -1
#property indicator_maximum  1

//
//
//
//
//

extern int FastPeriod   = 12;
extern int SlowPeriod   = 26;
extern int SignalPeriod = PRICE_CLOSE;
extern int Price        = PRICE_CLOSE;

//
//
//
//
//

double histu[];
double histd[];
double state[];
double macd[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,histu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,state);
   SetIndexBuffer(3,macd);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
    
      for(int i = limit; i>=0; i--)
      {
         macd[i] = iMA(NULL,0,FastPeriod,0,MODE_EMA,Price,i)-iMA(NULL,0,SlowPeriod,0,MODE_EMA,Price,i);
            state[i] = state[i+1];
            histu[i] = EMPTY_VALUE;
            histd[i] = EMPTY_VALUE;
            if (macd[i]>macd[i+1]) state[i] =  1;
            if (macd[i]<macd[i+1]) state[i] = -1;
               if (state[i] != state[i+1] && state[i] ==  1) histu[i] =  1;
               if (state[i] != state[i+1] && state[i] == -1) histd[i] = -1;
      }            
   return(0);
}

